<template>
  <GManageTable
    :card="card"
    :i18n-base="i18nBase"
    v-bind="$attrs"
    :headers="headers"
    :items="value.software"
    use-wrapper
    :get-new-item="getNewItem"
    :optional="optional"
    :wiki-entry="wikiEntry"
    no-dialog-header
    @create="create"
    @edit="edit"
    @remove="remove"
    @deleteElement="$emit('delete')"
  >
    <template #form="{ item, updateAvailableElements }">
      <Software
        v-model="item.value"
        :update-available-elements="updateAvailableElements"
      />
    </template>

    <template #[`item.name`]="{ item }">
      {{ getForCurrentLocale(item.name) }}
    </template>
    <template #[`item.description`]="{ item }">
      <div class="text-truncate default-max-width">
        {{ getForCurrentLocale(item.description) }}
      </div>
    </template>
    <template #[`item.type`]="{ item }">
      <span v-if="item.type">{{
        $t(`dcc.common.softwareType.type.${item.type._text}`)
      }}</span>
      <span v-else>-</span>
    </template>
  </GManageTable>
</template>

<script>
import { SoftwareType } from "@d-ptb/dcc-js";
import { removeFromArray } from "assets/util/general";
import { validatableMixin } from "../../Mixins/validatableMixin";
import GManageTable from "~/components/App/Common/ManagementTable/GManageTable";
import { localizationMixin } from "~/components/Mixins/localizationMixin";
import Software from "@/components/DCC/Common/Software";

export default {
  name: "SoftwareList",
  components: {
    Software,
    GManageTable,
  },
  mixins: [validatableMixin, localizationMixin],
  props: {
    value: Object,
    i18nBase: {
      type: String,
      default: "dcc.common.softwareListType",
    },
    card: {
      type: Boolean,
      default: true,
    },
    optional: {
      type: Boolean,
      default: false,
    },
    wikiEntry: {
      type: String,
    },
  },
  data() {
    return {
      headers: [
        {
          text: this.$t("dcc.common.softwareType.name"),
          value: "name",
        },
        {
          text: this.$t("dcc.common.softwareType.release"),
          value: "release._text",
        },
        {
          text: this.$t("dcc.common.softwareType.description"),
          value: "description",
          sortable: false,
        },
        {
          text: this.$t("dcc.common.softwareType.type.title"),
          value: "type",
        },
      ],
      mode: "edit",
    };
  },
  computed: {
    customRules() {
      return [
        () =>
          this.value.software.length > 0 || this.$t(`${this.i18nBase}.empty`),
      ];
    },
  },
  watch: {
    "value.software"() {
      this.validate();
    },
  },
  methods: {
    remove(item) {
      removeFromArray(this.value.software, item);
    },
    create(item) {
      this.value.software.push(new SoftwareType(item));
      this.mode = "edit";
    },
    edit(item, index) {
      this.$set(this.value.software, index, undefined);
      this.$set(this.value.software, index, new SoftwareType(item));
    },
    getNewItem() {
      return new SoftwareType();
    },
  },
};
</script>
